Index: CPC stuff/cpc_serial_2313/cpcser.net
===================================================================
--- CPC stuff/cpc_serial_2313/cpcser.net	(revision cb32b0b109b7f5f7691007b348c4b8053660462d)
+++ CPC stuff/cpc_serial_2313/cpcser.net	(revision 0be09cac6f9b6331332a84ed4bc6e720087792b7)
@@ -1,132 +1,132 @@
-# EESchema Netlist Version 1.1 created  07/11/2010 23:41:46
+# EESchema Netlist Version 1.1 created  14/05/2011 19:38:46
 (
  ( /4CB35A37 $noname  X1 CRYSTAL {Lib=CRYSTAL}
-  (    1 N-000004 )
-  (    2 N-000003 )
+  (    1 N-000003 )
+  (    2 N-000002 )
  )
  ( /4CB347C7 $noname  D9 DIODE {Lib=DIODE}
-  (    1 N-000021 )
-  (    2 N-000049 )
+  (    1 N-000015 )
+  (    2 INT )
  )
  ( /4CB34649 $noname  U4 74LS02 {Lib=74LS02}
-  (    1 N-000075 )
-  (    2 N-000019 )
-  (    3 N-000055 )
-  (    4 N-000076 )
-  (    5 N-000078 )
-  (    6 N-000054 )
+  (    1 N-000072 )
+  (    2 A2 )
+  (    3 A7 )
+  (    4 N-000073 )
+  (    5 N-000075 )
+  (    6 IORQ )
   (    7 GND )
-  (    8 N-000012 )
-  (    9 N-000076 )
-  (   10 N-000050 )
-  (   11 N-000076 )
-  (   12 N-000079 )
-  (   13 N-000051 )
-  (   14 VCC )
+  (    8 RD )
+  (    9 N-000073 )
+  (   10 READ )
+  (   11 N-000073 )
+  (   12 WR )
+  (   13 WRITE )
+  (   14 +5V )
  )
  ( /4CADB4AE $noname  D2 DIODE {Lib=DIODE}
-  (    1 N-000078 )
-  (    2 N-000075 )
+  (    1 N-000075 )
+  (    2 N-000072 )
  )
  ( /4CADB241 $noname  D7 DIODE {Lib=DIODE}
-  (    1 N-000078 )
-  (    2 N-000027 )
+  (    1 N-000075 )
+  (    2 A5 )
  )
  ( /4CADB240 $noname  D8 DIODE {Lib=DIODE}
-  (    1 N-000078 )
-  (    2 N-000029 )
+  (    1 N-000075 )
+  (    2 A6 )
  )
  ( /4CADB201 $noname  D6 DIODE {Lib=DIODE}
-  (    1 N-000078 )
-  (    2 N-000025 )
+  (    1 N-000075 )
+  (    2 A4 )
  )
  ( /4CADB1FE $noname  D5 DIODE {Lib=DIODE}
-  (    1 N-000078 )
-  (    2 N-000022 )
+  (    1 N-000075 )
+  (    2 A3 )
  )
  ( /4CADB1FB $noname  D4 DIODE {Lib=DIODE}
-  (    1 N-000078 )
-  (    2 N-000016 )
+  (    1 N-000075 )
+  (    2 A1 )
  )
  ( /4CADB1F7 $noname  D3 DIODE {Lib=DIODE}
-  (    1 N-000078 )
-  (    2 N-000059 )
+  (    1 N-000075 )
+  (    2 A8 )
  )
  ( /4CACDDC9 $noname  C7 1µF {Lib=C}
   (    1 GND )
-  (    2 VCC )
+  (    2 +5V )
  )
  ( /4CACDD41 $noname  C3 1µF {Lib=CP1}
-  (    1 N-000039 )
+  (    1 N-000034 )
   (    2 GND )
  )
  ( /4CACDD34 $noname  C4 1µF {Lib=CP1}
   (    1 GND )
-  (    2 N-000035 )
+  (    2 N-000030 )
  )
  ( /4CACDD2D $noname  C2 1µF {Lib=CP1}
-  (    1 N-000037 )
-  (    2 N-000036 )
+  (    1 N-000032 )
+  (    2 N-000031 )
  )
  ( /4CACDD28 $noname  C1 1µF {Lib=CP1}
-  (    1 N-000040 )
-  (    2 N-000038 )
+  (    1 N-000035 )
+  (    2 N-000033 )
  )
  ( /4CACDC46 $noname  C5 22pF {Lib=C}
-  (    1 N-000004 )
-  (    2 GND )
- )
- ( /4CACDC41 $noname  C6 22pF {Lib=C}
   (    1 N-000003 )
   (    2 GND )
  )
+ ( /4CACDC41 $noname  C6 22pF {Lib=C}
+  (    1 N-000002 )
+  (    2 GND )
+ )
  ( /4CACD9E4 $noname  P2 FWUP {Lib=CONN_2}
-  (    1 N-000002 )
-  (    2 N-000080 )
+  (    1 N-000001 )
+  (    2 N-000077 )
  )
  ( /4CACD9BF $noname  R1 10MR {Lib=R}
   (    1 GND )
-  (    2 N-000002 )
+  (    2 N-000001 )
  )
  ( /4CACD9BD $noname  R2 470R {Lib=R}
-  (    1 N-000001 )
-  (    2 N-000080 )
+  (    1 N-000007 )
+  (    2 N-000077 )
  )
  ( /4CACD9B5 $noname  D1 LED {Lib=LED}
   (    1 GND )
-  (    2 N-000001 )
+  (    2 N-000007 )
  )
  ( /4CACD835 $noname  J1 DB9 {Lib=DB9}
-  (    1 ? )
-  (    2 N-000010 )
-  (    3 N-000077 )
-  (    4 ? )
+  (    1 N-000004 )
+  (    2 N-000005 )
+  (    3 N-000074 )
+  (    4 N-000004 )
   (    5 GND )
-  (    6 ? )
-  (    7 ? )
-  (    8 ? )
+  (    6 N-000004 )
+  (    7 N-000048 )
+  (    8 N-000048 )
   (    9 ? )
  )
  ( /4CACCD81 $noname  U2 ATTINY2313MLF {Lib=ATTINY2313MLF}
-  (    1 N-000053 )
-  (    2 N-000030 )
-  (    3 N-000052 )
-  (    4 N-000004 )
-  (    5 N-000003 )
-  (    6 N-000051 )
-  (    7 N-000050 )
-  (    8 N-000049 )
-  (    9 N-000048 )
+  (    1 RESET )
+  (    2 RX )
+  (    3 TX )
+  (    4 N-000003 )
+  (    5 N-000002 )
+  (    6 WRITE )
+  (    7 READ )
+  (    8 INT )
+  (    9 A0 )
   (   10 GND )
-  (   11 N-000080 )
-  (   12 N-000047 )
-  (   13 N-000046 )
-  (   14 N-000073 )
-  (   15 N-000072 )
-  (   16 N-000071 )
-  (   17 N-000070 )
-  (   18 N-000069 )
-  (   19 N-000068 )
-  (   20 VCC )
+  (   11 N-000077 )
+  (   12 D0 )
+  (   13 D1 )
+  (   14 D2 )
+  (   15 D3 )
+  (   16 D4 )
+  (   17 D5 )
+  (   18 D6 )
+  (   19 D7 )
+  (   20 +5V )
  )
  ( /4CACCCFC $noname  P1 CONN_25X2 {Lib=CONN_25X2}
@@ -140,30 +140,30 @@
   (    8 ? )
   (    9 ? )
-  (   10 N-000059 )
-  (   11 N-000055 )
-  (   12 N-000029 )
-  (   13 N-000027 )
-  (   14 N-000025 )
-  (   15 N-000022 )
-  (   16 N-000019 )
-  (   17 N-000016 )
-  (   18 N-000048 )
-  (   19 N-000068 )
-  (   20 N-000069 )
-  (   21 N-000070 )
-  (   22 N-000071 )
-  (   23 N-000072 )
-  (   24 N-000073 )
-  (   25 N-000046 )
-  (   26 N-000047 )
-  (   27 VCC )
+  (   10 A8 )
+  (   11 A7 )
+  (   12 A6 )
+  (   13 A5 )
+  (   14 A4 )
+  (   15 A3 )
+  (   16 A2 )
+  (   17 A1 )
+  (   18 A0 )
+  (   19 D7 )
+  (   20 D6 )
+  (   21 D5 )
+  (   22 D4 )
+  (   23 D3 )
+  (   24 D2 )
+  (   25 D1 )
+  (   26 D0 )
+  (   27 +5V )
   (   28 ? )
   (   29 ? )
   (   30 ? )
-  (   31 N-000054 )
-  (   32 N-000012 )
-  (   33 N-000079 )
+  (   31 IORQ )
+  (   32 RD )
+  (   33 WR )
   (   34 ? )
-  (   35 N-000021 )
+  (   35 N-000015 )
   (   36 ? )
   (   37 ? )
@@ -171,5 +171,5 @@
   (   39 ? )
   (   40 ? )
-  (   41 N-000053 )
+  (   41 RESET )
   (   42 ? )
   (   43 ? )
@@ -183,20 +183,20 @@
  )
  ( /4CACCC83 $noname  U3 MAX232 {Lib=MAX232}
-  (    1 N-000040 )
-  (    2 N-000039 )
-  (    3 N-000038 )
-  (    4 N-000037 )
-  (    5 N-000036 )
-  (    6 N-000035 )
+  (    1 N-000035 )
+  (    2 N-000034 )
+  (    3 N-000033 )
+  (    4 N-000032 )
+  (    5 N-000031 )
+  (    6 N-000030 )
   (    7 ? )
   (    8 ? )
   (    9 ? )
   (   10 ? )
-  (   11 N-000052 )
-  (   12 N-000030 )
-  (   13 N-000077 )
-  (   14 N-000010 )
+  (   11 TX )
+  (   12 RX )
+  (   13 N-000074 )
+  (   14 N-000005 )
   (   15 GND )
-  (   16 VCC )
+  (   16 +5V )
  )
 )
@@ -300,165 +300,166 @@
 { Pin List by Nets
 Net 1 "" ""
- D1 2
- R2 1
-Net 2 "" ""
  R1 2
  P2 1
+Net 2 "" ""
+ X1 2
+ U2 5
+ C6 1
 Net 3 "" ""
- U2 5
- X1 2
- C6 1
-Net 4 "" ""
  X1 1
  C5 1
  U2 4
-Net 10 "" ""
+Net 4 "" ""
+ J1 4
+ J1 1
+ J1 6
+Net 5 "" ""
+ J1 2
  U3 14
- J1 2
-Net 12 "" ""
+Net 6 "RD" "RD"
  P1 32
  U4 8
-Net 13 "VCC" "VCC"
- U4 14
+Net 7 "" ""
+ R2 1
+ D1 2
+Net 8 "+5V" "+5V"
  C7 2
  U4 14
+ P1 27
+ U3 16
  U2 20
- U3 16
- U4 14
- U4 14
- P1 27
-Net 16 "" ""
+Net 10 "A1" "A1"
  P1 17
  D4 2
-Net 19 "" ""
+Net 13 "A2" "A2"
+ P1 16
  U4 2
- P1 16
-Net 21 "" ""
+Net 15 "" ""
  P1 35
  D9 1
-Net 22 "" ""
+Net 16 "A3" "A3"
+ P1 15
  D5 2
- P1 15
-Net 25 "" ""
+Net 19 "A4" "A4"
+ D6 2
  P1 14
- D6 2
-Net 27 "" ""
+Net 21 "A5" "A5"
+ P1 13
  D7 2
- P1 13
-Net 29 "" ""
+Net 23 "A6" "A6"
  D8 2
  P1 12
+Net 24 "RX" "RX"
+ U3 12
+ U2 2
+Net 25 "TX" "TX"
+ U3 11
+ U2 3
 Net 30 "" ""
- U2 2
- U3 12
-Net 35 "" ""
  C4 2
  U3 6
-Net 36 "" ""
+Net 31 "" ""
+ U3 5
  C2 2
- U3 5
-Net 37 "" ""
+Net 32 "" ""
+ U3 4
  C2 1
- U3 4
-Net 38 "" ""
+Net 33 "" ""
  U3 3
  C1 2
-Net 39 "" ""
+Net 34 "" ""
  U3 2
  C3 1
-Net 40 "" ""
+Net 35 "" ""
  U3 1
  C1 1
-Net 46 "" ""
+Net 42 "A0" "A0"
+ U2 9
+ P1 18
+Net 43 "INT" "INT"
+ D9 2
+ U2 8
+Net 44 "READ" "READ"
+ U4 10
+ U2 7
+Net 45 "WRITE" "WRITE"
+ U4 13
+ U2 6
+Net 46 "RESET" "RESET"
+ U2 1
+ P1 41
+Net 48 "" ""
+ J1 8
+ J1 7
+Net 49 "IORQ" "IORQ"
+ U4 6
+ P1 31
+Net 50 "A7" "A7"
+ U4 3
+ P1 11
+Net 54 "A8" "A8"
+ D3 2
+ P1 10
+Net 63 "D7" "D7"
+ P1 19
+ U2 19
+Net 64 "D6" "D6"
+ P1 20
+ U2 18
+Net 65 "D5" "D5"
+ U2 17
+ P1 21
+Net 66 "D4" "D4"
+ U2 16
+ P1 22
+Net 67 "D3" "D3"
+ P1 23
+ U2 15
+Net 68 "D2" "D2"
+ P1 24
+ U2 14
+Net 69 "D1" "D1"
  P1 25
  U2 13
-Net 47 "" ""
+Net 70 "D0" "D0"
+ U2 12
  P1 26
- U2 12
-Net 48 "" ""
- U2 9
- P1 18
-Net 49 "" ""
- U2 8
- D9 2
-Net 50 "" ""
- U2 7
- U4 10
-Net 51 "" ""
- U4 13
- U2 6
-Net 52 "" ""
- U2 3
- U3 11
-Net 53 "" ""
- U2 1
- P1 41
-Net 54 "" ""
- P1 31
- U4 6
-Net 55 "" ""
- P1 11
- U4 3
-Net 59 "" ""
- D3 2
- P1 10
-Net 68 "" ""
- U2 19
- P1 19
-Net 69 "" ""
- P1 20
- U2 18
-Net 70 "" ""
- U2 17
- P1 21
-Net 71 "" ""
- U2 16
- P1 22
-Net 72 "" ""
- U2 15
- P1 23
-Net 73 "" ""
- U2 14
- P1 24
-Net 74 "GND" "GND"
- U4 7
- C5 2
+Net 71 "GND" "GND"
+ U3 15
  D1 1
  U4 7
- C6 2
- U4 7
+ C3 2
+ C7 1
+ J1 5
+ C4 1
  R1 1
- J1 5
- U3 15
  P1 49
+ C5 2
  U2 10
  P1 2
- U4 7
- C7 1
- C3 2
- C4 1
-Net 75 "" ""
+ C6 2
+Net 72 "" ""
  D2 2
  U4 1
-Net 76 "" ""
+Net 73 "" ""
  U4 11
  U4 9
  U4 4
-Net 77 "" ""
+Net 74 "" ""
+ J1 3
  U3 13
- J1 3
-Net 78 "" ""
+Net 75 "" ""
+ D7 1
  D2 1
- D7 1
  D3 1
  D4 1
  D5 1
+ D6 1
  U4 5
  D8 1
- D6 1
-Net 79 "" ""
+Net 76 "WR" "WR"
+ P1 33
  U4 12
- P1 33
-Net 80 "" ""
+Net 77 "" ""
  U2 11
  R2 2