Index: CPC stuff/gemini/ramcard.net
===================================================================
--- CPC stuff/gemini/ramcard.net	(revision 8e213bef082006e6b0c1581d2fb43e0fa083db95)
+++ CPC stuff/gemini/ramcard.net	(revision 7d84448b6037c7741101861dd6ea66c12c1108c2)
@@ -2,5 +2,5 @@
   (design
     (source "C:\\Users\\pulkomandy\\Documents\\GitHub\\avrstuff\\CPC stuff\\gemini\\ramcard.sch")
-    (date "10/10/2021 23:35:31")
+    (date "21/01/2022 20:25:40")
     (tool "Eeschema (5.1.10)-1")
     (sheet (number 1) (name /) (tstamps /)
@@ -16,11 +16,4 @@
         (comment (number 4) (value "")))))
   (components
-    (comp (ref U2)
-      (value 74LS574)
-      (footprint Package_SO:SOIC-20W_7.5x12.8mm_P1.27mm)
-      (datasheet http://www.ti.com/lit/gpn/sn74LS574)
-      (libsource (lib 74xx) (part 74LS574) (description "8-bit Register, 3-state outputs"))
-      (sheetpath (names /) (tstamps /))
-      (tstamp 5FB3A5F5))
     (comp (ref C1)
       (value C)
@@ -131,36 +124,55 @@
       (libsource (lib Device) (part R) (description Resistor))
       (sheetpath (names /) (tstamps /))
-      (tstamp 61E51CEA)))
+      (tstamp 61E51CEA))
+    (comp (ref D3)
+      (value DIODE)
+      (footprint Diodes_SMD:D_1206)
+      (datasheet ~)
+      (libsource (lib pspice) (part DIODE) (description "Diode symbol for simulation only. Pin order incompatible with official kicad footprints"))
+      (sheetpath (names /) (tstamps /))
+      (tstamp 6165927E))
+    (comp (ref U2)
+      (value 74AHCT273)
+      (footprint Housings_SOIC:SOIC-20W_7.5x12.8mm_Pitch1.27mm)
+      (datasheet https://assets.nexperia.com/documents/data-sheet/74AHC_AHCT273.pdf)
+      (libsource (lib 74xx) (part 74AHCT273) (description "8-bit D Flip-Flop, reset"))
+      (sheetpath (names /) (tstamps /))
+      (tstamp 61EB5442)))
   (libparts
-    (libpart (lib 74xx) (part 74LS574)
+    (libpart (lib 74xx) (part 74LS273)
       (aliases
-        (alias 74HCT574))
-      (description "8-bit Register, 3-state outputs")
-      (docs http://www.ti.com/lit/gpn/sn74LS574)
-      (footprints
-        (fp DIP?20*))
+        (alias 74HC273)
+        (alias 74HCT273)
+        (alias 74AHC273)
+        (alias 74AHCT273))
+      (description "8-bit D Flip-Flop, reset")
+      (docs http://www.ti.com/lit/gpn/sn74LS273)
+      (footprints
+        (fp DIP?20*)
+        (fp SO?20*)
+        (fp SOIC?20*))
       (fields
         (field (name Reference) U)
-        (field (name Value) 74LS574))
-      (pins
-        (pin (num 1) (name OE) (type input))
-        (pin (num 2) (name D0) (type input))
-        (pin (num 3) (name D1) (type input))
-        (pin (num 4) (name D2) (type input))
-        (pin (num 5) (name D3) (type input))
-        (pin (num 6) (name D4) (type input))
-        (pin (num 7) (name D5) (type input))
-        (pin (num 8) (name D6) (type input))
-        (pin (num 9) (name D7) (type input))
+        (field (name Value) 74LS273))
+      (pins
+        (pin (num 1) (name ~Mr) (type input))
+        (pin (num 2) (name Q0) (type output))
+        (pin (num 3) (name D0) (type input))
+        (pin (num 4) (name D1) (type input))
+        (pin (num 5) (name Q1) (type output))
+        (pin (num 6) (name Q2) (type output))
+        (pin (num 7) (name D2) (type input))
+        (pin (num 8) (name D3) (type input))
+        (pin (num 9) (name Q3) (type output))
         (pin (num 10) (name GND) (type power_in))
         (pin (num 11) (name Cp) (type input))
-        (pin (num 12) (name Q7) (type 3state))
-        (pin (num 13) (name Q6) (type 3state))
-        (pin (num 14) (name Q5) (type 3state))
-        (pin (num 15) (name Q4) (type 3state))
-        (pin (num 16) (name Q3) (type 3state))
-        (pin (num 17) (name Q2) (type 3state))
-        (pin (num 18) (name Q1) (type 3state))
-        (pin (num 19) (name Q0) (type 3state))
+        (pin (num 12) (name Q4) (type output))
+        (pin (num 13) (name D4) (type input))
+        (pin (num 14) (name D5) (type input))
+        (pin (num 15) (name Q5) (type output))
+        (pin (num 16) (name Q6) (type output))
+        (pin (num 17) (name D6) (type input))
+        (pin (num 18) (name D7) (type input))
+        (pin (num 19) (name Q7) (type output))
         (pin (num 20) (name VCC) (type power_in))))
     (libpart (lib 74xx) (part 74LS688)
@@ -396,10 +408,19 @@
         (pin (num 4) (name A) (type passive))
         (pin (num 5) (name B) (type passive))
-        (pin (num 6) (name C) (type passive)))))
+        (pin (num 6) (name C) (type passive))))
+    (libpart (lib pspice) (part DIODE)
+      (description "Diode symbol for simulation only. Pin order incompatible with official kicad footprints")
+      (docs ~)
+      (fields
+        (field (name Reference) D)
+        (field (name Value) DIODE))
+      (pins
+        (pin (num 1) (name K) (type input))
+        (pin (num 2) (name A) (type input)))))
   (libraries
     (library (logical 74xx)
       (uri "C:\\Program Files\\KiCad\\share\\kicad\\library/74xx.lib"))
     (library (logical ATF22v10)
-      (uri "C:\\Users\\pulkomandy\\Documents\\GitHub\\avrstuff\\CPC stuff\\kicadlibs\\2021-10-10_11-41-49\\2021-10-10_11-41-49.lib"))
+      (uri "C:/Users/pulkomandy/Documents/GitHub/avrstuff/CPC stuff/kicadlibs/2021-10-10_11-41-49/2021-10-10_11-41-49.lib"))
     (library (logical Connector_Generic)
       (uri "C:\\Program Files\\KiCad\\share\\kicad\\library/Connector_Generic.lib"))
@@ -409,289 +430,294 @@
       (uri "C:\\Users\\pulkomandy\\Documents\\GitHub\\avrstuff\\CPC stuff\\gemini/LY6220488.lib"))
     (library (logical Switch)
-      (uri "C:\\Program Files\\KiCad\\share\\kicad\\library/Switch.lib")))
+      (uri "C:\\Program Files\\KiCad\\share\\kicad\\library/Switch.lib"))
+    (library (logical pspice)
+      (uri "C:\\Program Files\\KiCad\\share\\kicad\\library/pspice.lib")))
   (nets
-    (net (code 1) (name "Net-(J1-Pad30)")
-      (node (ref J1) (pin 30)))
-    (net (code 2) (name "Net-(J1-Pad34)")
-      (node (ref J1) (pin 34)))
-    (net (code 3) (name "Net-(J1-Pad36)")
-      (node (ref J1) (pin 36)))
-    (net (code 4) (name "Net-(J1-Pad38)")
+    (net (code 1) (name "Net-(J1-Pad40)")
+      (node (ref J1) (pin 40)))
+    (net (code 2) (name "Net-(J1-Pad42)")
+      (node (ref J1) (pin 42)))
+    (net (code 3) (name "Net-(D3-Pad2)")
+      (node (ref D3) (pin 2))
+      (node (ref J1) (pin 45)))
+    (net (code 4) (name /NCO)
+      (node (ref U5) (pin 19))
+      (node (ref U3) (pin 3)))
+    (net (code 5) (name /A8)
+      (node (ref U3) (pin 4))
+      (node (ref J1) (pin 10))
+      (node (ref SW1) (pin 6))
+      (node (ref U4) (pin 39)))
+    (net (code 6) (name /A9)
+      (node (ref J1) (pin 9))
+      (node (ref U3) (pin 5))
+      (node (ref U4) (pin 28))
+      (node (ref SW1) (pin 3)))
+    (net (code 7) (name "Net-(U3-Pad6)")
+      (node (ref U3) (pin 6)))
+    (net (code 8) (name "Net-(J1-Pad38)")
       (node (ref J1) (pin 38)))
-    (net (code 5) (name /A14)
-      (node (ref J1) (pin 4))
-      (node (ref U1) (pin 10)))
-    (net (code 6) (name /MA7)
-      (node (ref SW1) (pin 2))
-      (node (ref U2) (pin 8)))
-    (net (code 7) (name /MA8)
-      (node (ref U2) (pin 9))
-      (node (ref SW1) (pin 5)))
-    (net (code 8) (name /A12)
-      (node (ref J1) (pin 6))
-      (node (ref U4) (pin 25)))
-    (net (code 9) (name /RAMDIS)
-      (node (ref J1) (pin 45))
+    (net (code 9) (name /~CRTC)
+      (node (ref U3) (pin 2))
+      (node (ref U1) (pin 15)))
+    (net (code 10) (name /RMR2)
+      (node (ref U1) (pin 16)))
+    (net (code 11) (name /ASIC)
+      (node (ref D2) (pin 1))
+      (node (ref U1) (pin 17)))
+    (net (code 12) (name /RAMDIS)
+      (node (ref U4) (pin 40))
       (node (ref U1) (pin 19))
-      (node (ref U4) (pin 40)))
-    (net (code 10) (name "Net-(J1-Pad42)")
-      (node (ref J1) (pin 42)))
-    (net (code 11) (name "Net-(J1-Pad40)")
-      (node (ref J1) (pin 40)))
-    (net (code 12) (name GND)
-      (node (ref R2) (pin 1))
-      (node (ref C4) (pin 2))
-      (node (ref U5) (pin 1))
-      (node (ref C6) (pin 2))
-      (node (ref U5) (pin 10))
-      (node (ref U4) (pin 34))
-      (node (ref U2) (pin 10))
-      (node (ref U2) (pin 1))
-      (node (ref U3) (pin 13))
-      (node (ref U3) (pin 12))
-      (node (ref U4) (pin 12))
-      (node (ref R1) (pin 1))
-      (node (ref C5) (pin 2))
-      (node (ref C3) (pin 2))
-      (node (ref J1) (pin 2))
-      (node (ref SW1) (pin 1))
-      (node (ref SW1) (pin 4))
-      (node (ref U1) (pin 12))
-      (node (ref C2) (pin 2))
-      (node (ref C1) (pin 2))
-      (node (ref J1) (pin 49)))
-    (net (code 13) (name /CRTC)
-      (node (ref U1) (pin 15))
-      (node (ref U3) (pin 2)))
-    (net (code 14) (name /RMR2)
-      (node (ref U1) (pin 16)))
-    (net (code 15) (name /RAMWR)
+      (node (ref D3) (pin 1)))
+    (net (code 13) (name /XA15)
+      (node (ref U4) (pin 22))
+      (node (ref U1) (pin 20)))
+    (net (code 14) (name /XA14)
+      (node (ref U4) (pin 23))
+      (node (ref U1) (pin 21)))
+    (net (code 15) (name /~RAMWR)
       (node (ref U1) (pin 22))
       (node (ref U4) (pin 17)))
-    (net (code 16) (name /XA14)
-      (node (ref U4) (pin 23))
-      (node (ref U1) (pin 21)))
-    (net (code 17) (name /XA15)
-      (node (ref U4) (pin 22))
-      (node (ref U1) (pin 20)))
-    (net (code 18) (name /UNLOCK)
-      (node (ref D1) (pin 1))
-      (node (ref U3) (pin 22))
-      (node (ref U1) (pin 18)))
-    (net (code 19) (name /ASIC)
-      (node (ref D2) (pin 1))
-      (node (ref U1) (pin 17)))
-    (net (code 20) (name VCC)
-      (node (ref C1) (pin 1))
-      (node (ref U2) (pin 20))
-      (node (ref C2) (pin 1))
-      (node (ref J1) (pin 27))
-      (node (ref U3) (pin 24))
-      (node (ref C5) (pin 1))
-      (node (ref U5) (pin 20))
-      (node (ref C3) (pin 1))
-      (node (ref U4) (pin 33))
-      (node (ref U1) (pin 24))
-      (node (ref C6) (pin 1))
-      (node (ref U4) (pin 11))
-      (node (ref C4) (pin 1)))
-    (net (code 21) (name /D0)
-      (node (ref U5) (pin 12))
-      (node (ref J1) (pin 26))
-      (node (ref U2) (pin 2))
-      (node (ref U4) (pin 9)))
-    (net (code 22) (name /D1)
+    (net (code 16) (name "Net-(J1-Pad30)")
+      (node (ref J1) (pin 30)))
+    (net (code 17) (name "Net-(J1-Pad34)")
+      (node (ref J1) (pin 34)))
+    (net (code 18) (name "Net-(J1-Pad36)")
+      (node (ref J1) (pin 36)))
+    (net (code 19) (name "Net-(D1-Pad2)")
+      (node (ref R1) (pin 2))
+      (node (ref D1) (pin 2)))
+    (net (code 20) (name /PRBS7)
+      (node (ref U5) (pin 2))
+      (node (ref U3) (pin 23)))
+    (net (code 21) (name "Net-(D2-Pad2)")
+      (node (ref D2) (pin 2))
+      (node (ref R2) (pin 2)))
+    (net (code 22) (name /CLKIN)
+      (node (ref U3) (pin 1))
+      (node (ref U3) (pin 14)))
+    (net (code 23) (name /D7)
+      (node (ref U5) (pin 3))
+      (node (ref J1) (pin 19))
+      (node (ref U4) (pin 36))
+      (node (ref U1) (pin 2)))
+    (net (code 24) (name /D6)
+      (node (ref U5) (pin 5))
+      (node (ref U4) (pin 35))
+      (node (ref U1) (pin 3))
+      (node (ref J1) (pin 20)))
+    (net (code 25) (name /D5)
+      (node (ref U4) (pin 32))
+      (node (ref J1) (pin 21))
+      (node (ref U1) (pin 4))
+      (node (ref U5) (pin 7))
+      (node (ref U2) (pin 14)))
+    (net (code 26) (name /D4)
+      (node (ref U5) (pin 9))
+      (node (ref U2) (pin 13))
+      (node (ref J1) (pin 22))
+      (node (ref U4) (pin 31))
+      (node (ref U1) (pin 5)))
+    (net (code 27) (name /XA18)
+      (node (ref U4) (pin 19))
+      (node (ref U2) (pin 15)))
+    (net (code 28) (name /XA19)
+      (node (ref U4) (pin 18))
+      (node (ref U2) (pin 16)))
+    (net (code 29) (name /MA7)
+      (node (ref U2) (pin 17))
+      (node (ref SW1) (pin 2)))
+    (net (code 30) (name /MA8)
+      (node (ref U2) (pin 18))
+      (node (ref SW1) (pin 5)))
+    (net (code 31) (name /XA20)
+      (node (ref U4) (pin 16))
+      (node (ref U2) (pin 19)))
+    (net (code 32) (name /XD0)
+      (node (ref U1) (pin 9))
+      (node (ref U2) (pin 2)))
+    (net (code 33) (name /XD1)
+      (node (ref U1) (pin 8))
+      (node (ref U2) (pin 5)))
+    (net (code 34) (name /XA16)
+      (node (ref U2) (pin 9))
+      (node (ref U4) (pin 21)))
+    (net (code 35) (name /~RESET)
+      (node (ref U2) (pin 1))
+      (node (ref U1) (pin 13))
+      (node (ref J1) (pin 41))
+      (node (ref U3) (pin 7)))
+    (net (code 36) (name /XA17)
+      (node (ref U4) (pin 20))
+      (node (ref U2) (pin 12)))
+    (net (code 37) (name /~MMR)
+      (node (ref U2) (pin 11))
+      (node (ref U1) (pin 23)))
+    (net (code 38) (name /~MREQ)
+      (node (ref J1) (pin 28))
+      (node (ref U4) (pin 6)))
+    (net (code 39) (name /~WR)
+      (node (ref J1) (pin 33))
+      (node (ref U1) (pin 14)))
+    (net (code 40) (name /~IORQ)
+      (node (ref J1) (pin 31))
+      (node (ref U1) (pin 1)))
+    (net (code 41) (name /D3)
+      (node (ref U1) (pin 6))
+      (node (ref U2) (pin 8))
+      (node (ref U5) (pin 18))
+      (node (ref J1) (pin 23))
+      (node (ref U4) (pin 14)))
+    (net (code 42) (name /D2)
+      (node (ref U5) (pin 16))
+      (node (ref U4) (pin 13))
+      (node (ref U2) (pin 7))
+      (node (ref J1) (pin 24)))
+    (net (code 43) (name /D1)
+      (node (ref U5) (pin 14))
       (node (ref U4) (pin 10))
       (node (ref J1) (pin 25))
+      (node (ref U2) (pin 4)))
+    (net (code 44) (name /D0)
+      (node (ref U4) (pin 9))
+      (node (ref U5) (pin 12))
       (node (ref U2) (pin 3))
-      (node (ref U5) (pin 14)))
-    (net (code 23) (name /D2)
-      (node (ref U2) (pin 4))
-      (node (ref J1) (pin 24))
-      (node (ref U5) (pin 16))
-      (node (ref U4) (pin 13)))
-    (net (code 24) (name /D3)
-      (node (ref U2) (pin 5))
-      (node (ref U4) (pin 14))
-      (node (ref U5) (pin 18))
-      (node (ref U1) (pin 6))
-      (node (ref J1) (pin 23)))
-    (net (code 25) (name /NCO)
-      (node (ref U3) (pin 3))
-      (node (ref U5) (pin 19)))
-    (net (code 26) (name /PRBS6)
+      (node (ref J1) (pin 26)))
+    (net (code 45) (name "Net-(U3-Pad8)")
+      (node (ref U3) (pin 8)))
+    (net (code 46) (name "Net-(U3-Pad9)")
+      (node (ref U3) (pin 9)))
+    (net (code 47) (name "Net-(U3-Pad10)")
+      (node (ref U3) (pin 10)))
+    (net (code 48) (name "Net-(U3-Pad11)")
+      (node (ref U3) (pin 11)))
+    (net (code 49) (name /UNLOCK)
+      (node (ref U3) (pin 22))
+      (node (ref U1) (pin 18))
+      (node (ref D1) (pin 1)))
+    (net (code 50) (name VCC)
+      (node (ref U4) (pin 33))
+      (node (ref C4) (pin 1))
+      (node (ref J1) (pin 27))
+      (node (ref U2) (pin 20))
+      (node (ref U1) (pin 24))
+      (node (ref U5) (pin 20))
+      (node (ref C6) (pin 1))
+      (node (ref U3) (pin 24))
+      (node (ref U4) (pin 11))
+      (node (ref C5) (pin 1))
+      (node (ref C3) (pin 1))
+      (node (ref C2) (pin 1))
+      (node (ref C1) (pin 1)))
+    (net (code 51) (name /PRBS0)
+      (node (ref U3) (pin 15))
+      (node (ref U5) (pin 11)))
+    (net (code 52) (name /PRBS1)
+      (node (ref U3) (pin 16))
+      (node (ref U5) (pin 13)))
+    (net (code 53) (name /PRBS2)
+      (node (ref U5) (pin 15))
+      (node (ref U3) (pin 17)))
+    (net (code 54) (name /PRBS3)
+      (node (ref U5) (pin 17))
+      (node (ref U3) (pin 18)))
+    (net (code 55) (name /PRBS4)
+      (node (ref U3) (pin 19))
+      (node (ref U5) (pin 8)))
+    (net (code 56) (name /PRBS5)
+      (node (ref U3) (pin 20))
+      (node (ref U5) (pin 6)))
+    (net (code 57) (name /PRBS6)
       (node (ref U3) (pin 21))
       (node (ref U5) (pin 4)))
-    (net (code 27) (name /PRBS7)
-      (node (ref U3) (pin 23))
-      (node (ref U5) (pin 2)))
-    (net (code 28) (name "Net-(D1-Pad2)")
-      (node (ref D1) (pin 2))
-      (node (ref R1) (pin 2)))
-    (net (code 29) (name "Net-(D2-Pad2)")
-      (node (ref D2) (pin 2))
-      (node (ref R2) (pin 2)))
-    (net (code 30) (name /A9)
-      (node (ref U4) (pin 28))
-      (node (ref U3) (pin 5))
-      (node (ref J1) (pin 9)))
-    (net (code 31) (name /A8)
-      (node (ref U3) (pin 4))
-      (node (ref SW1) (pin 6))
-      (node (ref U4) (pin 39))
-      (node (ref J1) (pin 10)))
-    (net (code 32) (name /CLKIN)
-      (node (ref U3) (pin 1))
-      (node (ref U3) (pin 14)))
-    (net (code 33) (name /D4)
-      (node (ref U5) (pin 9))
-      (node (ref U4) (pin 31))
-      (node (ref U2) (pin 6))
-      (node (ref U1) (pin 5))
-      (node (ref J1) (pin 22)))
-    (net (code 34) (name /PRBS4)
-      (node (ref U3) (pin 19))
-      (node (ref U5) (pin 8)))
-    (net (code 35) (name /D5)
-      (node (ref U2) (pin 7))
-      (node (ref U4) (pin 32))
-      (node (ref U5) (pin 7))
-      (node (ref U1) (pin 4))
-      (node (ref J1) (pin 21)))
-    (net (code 36) (name /PRBS5)
-      (node (ref U5) (pin 6))
-      (node (ref U3) (pin 20)))
-    (net (code 37) (name /D6)
-      (node (ref U4) (pin 35))
-      (node (ref J1) (pin 20))
-      (node (ref U1) (pin 3))
-      (node (ref U5) (pin 5)))
-    (net (code 38) (name /RESET)
-      (node (ref U1) (pin 13))
-      (node (ref U3) (pin 7))
-      (node (ref J1) (pin 41)))
-    (net (code 39) (name "Net-(U3-Pad6)")
-      (node (ref U3) (pin 6)))
-    (net (code 40) (name "Net-(U3-Pad8)")
-      (node (ref U3) (pin 8)))
-    (net (code 41) (name "Net-(U3-Pad9)")
-      (node (ref U3) (pin 9)))
-    (net (code 42) (name /D7)
-      (node (ref U1) (pin 2))
-      (node (ref U5) (pin 3))
-      (node (ref J1) (pin 19))
-      (node (ref U4) (pin 36)))
-    (net (code 43) (name /PRBS3)
-      (node (ref U3) (pin 18))
-      (node (ref U5) (pin 17)))
-    (net (code 44) (name /PRBS2)
-      (node (ref U5) (pin 15))
-      (node (ref U3) (pin 17)))
-    (net (code 45) (name /PRBS1)
-      (node (ref U5) (pin 13))
-      (node (ref U3) (pin 16)))
-    (net (code 46) (name /PRBS0)
-      (node (ref U5) (pin 11))
-      (node (ref U3) (pin 15)))
-    (net (code 47) (name "Net-(U3-Pad11)")
-      (node (ref U3) (pin 11)))
-    (net (code 48) (name "Net-(U3-Pad10)")
-      (node (ref U3) (pin 10)))
-    (net (code 49) (name IORQ)
-      (node (ref J1) (pin 31))
-      (node (ref U1) (pin 1)))
-    (net (code 50) (name "Net-(J1-Pad1)")
-      (node (ref J1) (pin 1)))
-    (net (code 51) (name "Net-(J1-Pad29)")
+    (net (code 58) (name "Net-(J1-Pad35)")
+      (node (ref J1) (pin 35)))
+    (net (code 59) (name "Net-(J1-Pad37)")
+      (node (ref J1) (pin 37)))
+    (net (code 60) (name "Net-(J1-Pad39)")
+      (node (ref J1) (pin 39)))
+    (net (code 61) (name "Net-(J1-Pad43)")
+      (node (ref J1) (pin 43)))
+    (net (code 62) (name "Net-(J1-Pad47)")
+      (node (ref J1) (pin 47)))
+    (net (code 63) (name "Net-(J1-Pad32)")
+      (node (ref J1) (pin 32)))
+    (net (code 64) (name "Net-(J1-Pad29)")
       (node (ref J1) (pin 29)))
-    (net (code 52) (name "Net-(J1-Pad35)")
-      (node (ref J1) (pin 35)))
-    (net (code 53) (name "Net-(J1-Pad37)")
-      (node (ref J1) (pin 37)))
-    (net (code 54) (name "Net-(J1-Pad39)")
-      (node (ref J1) (pin 39)))
-    (net (code 55) (name "Net-(J1-Pad43)")
-      (node (ref J1) (pin 43)))
-    (net (code 56) (name "Net-(J1-Pad47)")
-      (node (ref J1) (pin 47)))
-    (net (code 57) (name WR)
-      (node (ref J1) (pin 33))
-      (node (ref U1) (pin 14)))
-    (net (code 58) (name "Net-(J1-Pad50)")
-      (node (ref J1) (pin 50)))
-    (net (code 59) (name "Net-(J1-Pad32)")
-      (node (ref J1) (pin 32)))
-    (net (code 60) (name RAMRD)
-      (node (ref U4) (pin 41))
-      (node (ref J1) (pin 44)))
-    (net (code 61) (name /MMR)
-      (node (ref U1) (pin 23))
-      (node (ref U2) (pin 11)))
-    (net (code 62) (name /A5)
-      (node (ref U4) (pin 44))
-      (node (ref J1) (pin 13)))
-    (net (code 63) (name /A4)
-      (node (ref J1) (pin 14))
-      (node (ref U4) (pin 1)))
-    (net (code 64) (name /A3)
-      (node (ref U4) (pin 2))
-      (node (ref J1) (pin 15)))
-    (net (code 65) (name /A2)
+    (net (code 65) (name /A3)
+      (node (ref J1) (pin 15))
+      (node (ref U4) (pin 2)))
+    (net (code 66) (name /A2)
       (node (ref J1) (pin 16))
       (node (ref U4) (pin 3)))
-    (net (code 66) (name /A1)
-      (node (ref J1) (pin 17))
-      (node (ref U4) (pin 4)))
-    (net (code 67) (name /A0)
+    (net (code 67) (name /A1)
+      (node (ref U4) (pin 4))
+      (node (ref J1) (pin 17)))
+    (net (code 68) (name /A0)
       (node (ref J1) (pin 18))
       (node (ref U4) (pin 5)))
-    (net (code 68) (name /XA16)
-      (node (ref U2) (pin 12))
-      (node (ref U4) (pin 21)))
     (net (code 69) (name "Net-(J1-Pad46)")
       (node (ref J1) (pin 46)))
     (net (code 70) (name "Net-(J1-Pad48)")
       (node (ref J1) (pin 48)))
-    (net (code 71) (name /XD0)
-      (node (ref U2) (pin 19))
-      (node (ref U1) (pin 9)))
-    (net (code 72) (name /XD1)
-      (node (ref U1) (pin 8))
-      (node (ref U2) (pin 18)))
-    (net (code 73) (name /XD2)
-      (node (ref U1) (pin 7))
-      (node (ref U2) (pin 17)))
-    (net (code 74) (name /XA18)
-      (node (ref U4) (pin 19))
-      (node (ref U2) (pin 14)))
-    (net (code 75) (name /XA17)
-      (node (ref U2) (pin 13))
-      (node (ref U4) (pin 20)))
-    (net (code 76) (name MREQ)
-      (node (ref U4) (pin 6))
-      (node (ref J1) (pin 28)))
-    (net (code 77) (name /A15)
+    (net (code 71) (name "Net-(J1-Pad50)")
+      (node (ref J1) (pin 50)))
+    (net (code 72) (name "Net-(J1-Pad1)")
+      (node (ref J1) (pin 1)))
+    (net (code 73) (name /A4)
+      (node (ref U4) (pin 1))
+      (node (ref J1) (pin 14)))
+    (net (code 74) (name /~RAMRD)
+      (node (ref U4) (pin 41))
+      (node (ref J1) (pin 44)))
+    (net (code 75) (name /A7)
+      (node (ref J1) (pin 11))
+      (node (ref U4) (pin 42)))
+    (net (code 76) (name /A6)
+      (node (ref J1) (pin 12))
+      (node (ref U4) (pin 43)))
+    (net (code 77) (name /A5)
+      (node (ref J1) (pin 13))
+      (node (ref U4) (pin 44)))
+    (net (code 78) (name /XD2)
+      (node (ref U2) (pin 6))
+      (node (ref U1) (pin 7)))
+    (net (code 79) (name /A14)
+      (node (ref U1) (pin 10))
+      (node (ref J1) (pin 4)))
+    (net (code 80) (name /A15)
       (node (ref U1) (pin 11))
       (node (ref J1) (pin 3)))
-    (net (code 78) (name /A13)
-      (node (ref U4) (pin 24))
-      (node (ref J1) (pin 5)))
-    (net (code 79) (name /A11)
+    (net (code 81) (name GND)
+      (node (ref U4) (pin 12))
+      (node (ref U5) (pin 10))
+      (node (ref U5) (pin 1))
+      (node (ref J1) (pin 49))
+      (node (ref C5) (pin 2))
+      (node (ref C3) (pin 2))
+      (node (ref SW1) (pin 1))
+      (node (ref C2) (pin 2))
+      (node (ref SW1) (pin 4))
+      (node (ref C1) (pin 2))
+      (node (ref C4) (pin 2))
+      (node (ref C6) (pin 2))
+      (node (ref U2) (pin 10))
+      (node (ref J1) (pin 2))
+      (node (ref R1) (pin 1))
+      (node (ref R2) (pin 1))
+      (node (ref U1) (pin 12))
+      (node (ref U3) (pin 13))
+      (node (ref U3) (pin 12))
+      (node (ref U4) (pin 34)))
+    (net (code 82) (name /A10)
+      (node (ref U4) (pin 27))
+      (node (ref J1) (pin 8)))
+    (net (code 83) (name /A13)
+      (node (ref J1) (pin 5))
+      (node (ref U4) (pin 24)))
+    (net (code 84) (name /A12)
+      (node (ref J1) (pin 6))
+      (node (ref U4) (pin 25)))
+    (net (code 85) (name /A11)
       (node (ref J1) (pin 7))
-      (node (ref U4) (pin 26)))
-    (net (code 80) (name /A10)
-      (node (ref J1) (pin 8))
-      (node (ref U4) (pin 27)))
-    (net (code 81) (name /XA19)
-      (node (ref U4) (pin 18))
-      (node (ref U2) (pin 15)))
-    (net (code 82) (name /XA20)
-      (node (ref U4) (pin 16))
-      (node (ref U2) (pin 16)))
-    (net (code 83) (name /A6)
-      (node (ref U4) (pin 43))
-      (node (ref J1) (pin 12)))
-    (net (code 84) (name /A7)
-      (node (ref U4) (pin 42))
-      (node (ref J1) (pin 11))
-      (node (ref SW1) (pin 3)))))
+      (node (ref U4) (pin 26)))))