Index: elec/MegaFlash/MegaROM.net
===================================================================
--- elec/MegaFlash/MegaROM.net	(revision bd954c67793c9fccf673103e733a7318302a6a7f)
+++ elec/MegaFlash/MegaROM.net	(revision 13bb075bbe47d087e0a66594e1561e8b5a96c275)
@@ -1,3 +1,3 @@
-# EESchema Netlist Version 1.1 created  03/01/2012 22:31:59
+# EESchema Netlist Version 1.1 created  04/01/2012 23:03:42
 (
  ( /4F036638 $noname  J1 MEMO7 {Lib=MEMO7}
@@ -31,13 +31,13 @@
  )
  ( /4F0361AF $noname  R1 R {Lib=R}
-  (    1 N-000008 )
+  (    1 N-000031 )
   (    2 GND )
  )
  ( /4F0361A8 $noname  C1 C {Lib=C}
   (    1 VCC )
-  (    2 N-000008 )
+  (    2 N-000031 )
  )
  ( /4F036198 $noname  U4 74LS373 {Lib=74LS373}
-  (    1 N-000045 )
+  (    1 //RES )
   (    2 /A14 )
   (    3 /D0 )
@@ -49,5 +49,5 @@
   (    9 /A17 )
   (   10 GND )
-  (   11 VCC )
+  (   11 N-000038 )
   (   12 /A18 )
   (   13 /D4 )
@@ -62,37 +62,37 @@
  ( /4F036181 $noname  U3 74LS133 {Lib=74LS133}
   (    1 /A7 )
-  (    2 /A13 )
-  (    3 /A8 )
-  (    4 /A9 )
-  (    5 /A11 )
-  (    6 /A1 )
-  (    7 /A0 )
+  (    2 /A6 )
+  (    3 /A5 )
+  (    4 /A4 )
+  (    5 /A3 )
+  (    6 /A2 )
+  (    7 /A10 )
   (    8 GND )
-  (    9 N-000007 )
-  (   10 /A10 )
-  (   11 /A2 )
-  (   12 /A3 )
-  (   13 /A4 )
-  (   14 /A5 )
-  (   15 /A6 )
+  (    9 N-000030 )
+  (   10 /A0 )
+  (   11 /A1 )
+  (   12 /A11 )
+  (   13 /A9 )
+  (   14 /A8 )
+  (   15 /A13 )
   (   16 VCC )
  )
  ( /4F036165 $noname  U1 74HC02 {Lib=74HC02}
-  (    1 N-000035 )
+  (    1 N-000032 )
   (    2 //CSN )
   (    3 /E )
-  (    4 N-000045 )
-  (    5 N-000031 )
-  (    6 N-000007 )
+  (    4 N-000038 )
+  (    5 N-000033 )
+  (    6 N-000030 )
   (    7 GND )
   (   14 VCC )
  )
  ( /4F036158 $noname  U2 74HC00 {Lib=74HC00}
-  (    1 N-000035 )
+  (    1 N-000032 )
   (    2 /A12 )
-  (    3 N-000031 )
-  (    4 ? )
-  (    5 ? )
-  (    6 ? )
+  (    3 N-000033 )
+  (    4 N-000031 )
+  (    5 N-000031 )
+  (    6 //RES )
   (    7 GND )
   (   14 VCC )
@@ -122,5 +122,5 @@
   (   22 //CSN )
   (   23 /A10 )
-  (   24 N-000045 )
+  (   24 N-000038 )
   (   25 /A11 )
   (   26 /A9 )
@@ -159,147 +159,151 @@
 { Pin List by Nets
 Net 5 "GND" "GND"
+ U5 16
+ R1 2
  U1 7
- R1 2
  U4 10
- U5 16
+ U2 7
  J1 26
- U2 7
  U3 8
 Net 6 "VCC" "VCC"
+ U1 14
+ U5 32
  C1 1
+ U4 20
+ U2 14
  U3 16
- U4 20
- U1 14
  J1 22
- U2 14
- U4 11
- U5 32
-Net 7 "" ""
- U3 9
- U1 6
-Net 8 "" ""
- R1 1
- C1 2
-Net 9 "/A19" "A19"
+Net 7 "//RES" "/RES"
+ U2 6
+ U4 1
+Net 8 "/A19" "A19"
+ U5 1
  U4 15
- U5 1
-Net 10 "/A16" "A16"
+Net 9 "/A16" "A16"
+ U4 6
  U5 2
- U4 6
-Net 11 "/A15" "A15"
+Net 10 "/A15" "A15"
+ U4 5
  U5 3
- U4 5
-Net 12 "/A12" "A12"
+Net 11 "/A12" "A12"
+ U2 2
  U5 4
  J1 20
- U2 2
-Net 13 "/A7" "A7"
+Net 12 "/A7" "A7"
  J1 15
+ U3 1
  U5 5
- U3 1
-Net 14 "/A6" "A6"
+Net 13 "/A6" "A6"
  J1 14
- U3 15
  U5 6
-Net 15 "/A5" "A5"
+ U3 2
+Net 14 "/A5" "A5"
+ J1 13
  U5 7
- U3 14
- J1 13
-Net 16 "/A4" "A4"
- U3 13
+ U3 3
+Net 15 "/A4" "A4"
  J1 12
+ U3 4
  U5 8
-Net 17 "/A3" "A3"
- U3 12
+Net 16 "/A3" "A3"
  J1 11
  U5 9
-Net 18 "/A2" "A2"
+ U3 5
+Net 17 "/A2" "A2"
  J1 10
+ U3 6
  U5 10
+Net 18 "/A17" "A17"
+ U5 30
+ U4 9
+Net 19 "/A1" "A1"
+ J1 9
  U3 11
-Net 19 "/A17" "A17"
- U4 9
- U5 30
-Net 20 "/A1" "A1"
- J1 9
- U3 6
  U5 11
-Net 21 "/A18" "A18"
+Net 20 "/A18" "A18"
  U5 31
  U4 12
-Net 22 "/A0" "A0"
+Net 21 "/A0" "A0"
+ U5 12
+ U3 10
  J1 8
- U5 12
+Net 22 "/A10" "A10"
+ J1 18
  U3 7
-Net 23 "/A10" "A10"
- J1 18
- U3 10
  U5 23
-Net 24 "/A11" "A11"
+Net 23 "/A11" "A11"
+ U5 25
  J1 19
- U3 5
- U5 25
-Net 25 "/A9" "A9"
+ U3 12
+Net 24 "/A9" "A9"
+ U5 26
  J1 17
- U3 4
- U5 26
-Net 26 "/A8" "A8"
+ U3 13
+Net 25 "/A8" "A8"
+ J1 16
+ U3 14
  U5 27
- U3 3
- J1 16
-Net 27 "/A13" "A13"
+Net 26 "/A13" "A13"
+ U5 28
+ U3 15
  J1 21
- U3 2
- U5 28
-Net 28 "/A14" "A14"
+Net 27 "/A14" "A14"
  U4 2
  U5 29
-Net 29 "//CSN" "/CSN"
+Net 28 "//CSN" "/CSN"
  U1 2
  U5 22
  J1 23
-Net 30 "/E" "E"
+Net 29 "/E" "E"
+ J1 24
  U1 3
- J1 24
+Net 30 "" ""
+ U1 6
+ U3 9
 Net 31 "" ""
+ R1 1
+ C1 2
+ U2 4
+ U2 5
+Net 32 "" ""
+ U1 1
+ U2 1
+Net 33 "" ""
  U2 3
  U1 5
-Net 35 "" ""
- U1 1
- U2 1
-Net 36 "/D7" "D7"
+Net 34 "/D7" "D7"
  U5 21
  J1 0
-Net 37 "/D6" "D6"
+Net 35 "/D6" "D6"
  U5 20
  J1 1
-Net 38 "/D5" "D5"
+Net 36 "/D5" "D5"
  U5 19
+ U4 14
  J1 2
- U4 14
-Net 39 "/D4" "D4"
- U4 13
+Net 37 "/D4" "D4"
  U5 18
  J1 3
-Net 40 "/D3" "D3"
- U5 17
+ U4 13
+Net 38 "" ""
+ U4 11
+ U1 4
+ U5 24
+Net 39 "/D3" "D3"
  U4 8
  J1 4
-Net 41 "/D2" "D2"
+ U5 17
+Net 40 "/D2" "D2"
+ J1 5
+ U5 15
  U4 7
- U5 15
- J1 5
-Net 42 "/D1" "D1"
+Net 41 "/D1" "D1"
+ U4 4
  U5 14
  J1 6
- U4 4
-Net 43 "/D0" "D0"
+Net 42 "/D0" "D0"
  U5 13
  U4 3
  J1 7
-Net 45 "" ""
- U1 4
- U5 24
- U4 1
 }
 #End